#include <complex>
#include <cstdlib>
#include "lapacke.h"

#ifndef INCLUDE_LAPACK_CALLS_H_
#include "../include/lapack_calls.h"
#endif

using namespace std;

void zinvert(std::complex<double> **mat, int n, int &jer) {
  jer = 0;
  __complex__ double *arr = new __complex__ double[n * n];
  const __complex__ double uim = 1.0di;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      int idx = i + n * j;
      arr[idx] = mat[j][i].real() + uim * mat[j][i].imag();
    }
  }
  
  int* IPIV = new int[n];
  
  LAPACKE_zgetrf(LAPACK_ROW_MAJOR, n, n, arr, n, IPIV);
  LAPACKE_zgetri(LAPACK_ROW_MAJOR, n, arr, n, IPIV);
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      int idx = i + n * j;
      mat[j][i] = complex<double>(__real__ arr[idx], __imag__ arr[idx]);
    }
  }
  delete [] IPIV;
  delete [] arr;
}
